Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SubtreeCrossover.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SubtreeCrossover.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SubtreeCrossover.cs	(revision 5510)
@@ -78,23 +78,23 @@
     }
 
-    protected override SymbolicExpressionTree Cross(IRandom random,
-      SymbolicExpressionTree parent0, SymbolicExpressionTree parent1) {
+    protected override ISymbolicExpressionTree Cross(IRandom random,
+      ISymbolicExpressionTree parent0, ISymbolicExpressionTree parent1) {
       return Cross(random, parent0, parent1, InternalCrossoverPointProbability.Value,
         MaximumSymbolicExpressionTreeLength.Value, MaximumSymbolicExpressionTreeDepth.Value);
     }
 
-    public static SymbolicExpressionTree Cross(IRandom random,
-      SymbolicExpressionTree parent0, SymbolicExpressionTree parent1,
+    public static ISymbolicExpressionTree Cross(IRandom random,
+      ISymbolicExpressionTree parent0, ISymbolicExpressionTree parent1,
       double internalCrossoverPointProbability, int maxTreeSize, int maxTreeHeight) {
       // select a random crossover point in the first parent 
-      SymbolicExpressionTreeNode crossoverPoint0;
+      ISymbolicExpressionTreeNode crossoverPoint0;
       int replacedSubtreeIndex;
       SelectCrossoverPoint(random, parent0, internalCrossoverPointProbability, maxTreeSize, maxTreeHeight, out crossoverPoint0, out replacedSubtreeIndex);
 
       // calculate the max size and height that the inserted branch can have 
-      int maxInsertedBranchSize = maxTreeSize - (parent0.Size - crossoverPoint0.SubTrees[replacedSubtreeIndex].GetSize());
+      int maxInsertedBranchSize = maxTreeSize - (parent0.Size - crossoverPoint0.GetSubTree(replacedSubtreeIndex).GetSize());
       int maxInsertedBranchHeight = maxTreeHeight - GetBranchLevel(parent0.Root, crossoverPoint0);
 
-      List<SymbolicExpressionTreeNode> allowedBranches = new List<SymbolicExpressionTreeNode>();
+      List<ISymbolicExpressionTreeNode> allowedBranches = new List<ISymbolicExpressionTreeNode>();
       parent1.Root.ForEachNodePostfix((n) => {
         if (n.GetSize() <= maxInsertedBranchSize &&
@@ -117,5 +117,5 @@
     }
 
-    private static bool IsMatchingPointType(SymbolicExpressionTreeNode parent, int replacedSubtreeIndex, SymbolicExpressionTreeNode branch) {
+    private static bool IsMatchingPointType(ISymbolicExpressionTreeNode parent, int replacedSubtreeIndex, ISymbolicExpressionTreeNode branch) {
       // check syntax constraints of direct parent - child relation
       if (!parent.Grammar.ContainsSymbol(branch.Symbol) ||
@@ -128,20 +128,20 @@
           result &&
           parent.Grammar.ContainsSymbol(n.Symbol) &&
-          n.SubTrees.Count >= parent.Grammar.GetMinSubtreeCount(n.Symbol) &&
-          n.SubTrees.Count <= parent.Grammar.GetMaxSubtreeCount(n.Symbol);
+          n.SubTrees.Count() >= parent.Grammar.GetMinSubtreeCount(n.Symbol) &&
+          n.SubTrees.Count() <= parent.Grammar.GetMaxSubtreeCount(n.Symbol);
       });
       return result;
     }
 
-    private static void SelectCrossoverPoint(IRandom random, SymbolicExpressionTree parent0, double internalNodeProbability, int maxBranchSize, int maxBranchHeight, out SymbolicExpressionTreeNode crossoverPoint, out int subtreeIndex) {
+    private static void SelectCrossoverPoint(IRandom random, ISymbolicExpressionTree parent0, double internalNodeProbability, int maxBranchSize, int maxBranchHeight, out ISymbolicExpressionTreeNode crossoverPoint, out int subtreeIndex) {
       if (internalNodeProbability < 0.0 || internalNodeProbability > 1.0) throw new ArgumentException("internalNodeProbability");
       List<CrossoverPoint> internalCrossoverPoints = new List<CrossoverPoint>();
       List<CrossoverPoint> leafCrossoverPoints = new List<CrossoverPoint>();
       parent0.Root.ForEachNodePostfix((n) => {
-        if (n.SubTrees.Count > 0 && n != parent0.Root) {
+        if (n.SubTrees.Count() > 0 && n != parent0.Root) {
           foreach (var child in n.SubTrees) {
             if (child.GetSize() <= maxBranchSize &&
                 child.GetHeight() <= maxBranchHeight) {
-              if (child.SubTrees.Count > 0)
+              if (child.SubTrees.Count() > 0)
                 internalCrossoverPoints.Add(new CrossoverPoint(n, child));
               else
@@ -178,12 +178,12 @@
     }
 
-    private static SymbolicExpressionTreeNode SelectRandomBranch(IRandom random, IEnumerable<SymbolicExpressionTreeNode> branches, double internalNodeProbability) {
+    private static ISymbolicExpressionTreeNode SelectRandomBranch(IRandom random, IEnumerable<ISymbolicExpressionTreeNode> branches, double internalNodeProbability) {
       if (internalNodeProbability < 0.0 || internalNodeProbability > 1.0) throw new ArgumentException("internalNodeProbability");
-      List<SymbolicExpressionTreeNode> allowedInternalBranches;
-      List<SymbolicExpressionTreeNode> allowedLeafBranches;
+      List<ISymbolicExpressionTreeNode> allowedInternalBranches;
+      List<ISymbolicExpressionTreeNode> allowedLeafBranches;
       if (random.NextDouble() < internalNodeProbability) {
         // select internal node if possible
         allowedInternalBranches = (from branch in branches
-                                   where branch.SubTrees.Count > 0
+                                   where branch.SubTrees.Count() > 0
                                    select branch).ToList();
         if (allowedInternalBranches.Count > 0) {
@@ -192,5 +192,5 @@
           // no internal nodes allowed => select leaf nodes
           allowedLeafBranches = (from branch in branches
-                                 where branch.SubTrees.Count == 0
+                                 where branch.SubTrees.Count() == 0
                                  select branch).ToList();
           return allowedLeafBranches.SelectRandom(random);
@@ -199,5 +199,5 @@
         // select leaf node if possible
         allowedLeafBranches = (from branch in branches
-                               where branch.SubTrees.Count == 0
+                               where branch.SubTrees.Count() == 0
                                select branch).ToList();
         if (allowedLeafBranches.Count > 0) {
@@ -205,5 +205,5 @@
         } else {
           allowedInternalBranches = (from branch in branches
-                                     where branch.SubTrees.Count > 0
+                                     where branch.SubTrees.Count() > 0
                                      select branch).ToList();
           return allowedInternalBranches.SelectRandom(random);
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SymbolicExpressionTreeCrossover.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SymbolicExpressionTreeCrossover.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SymbolicExpressionTreeCrossover.cs	(revision 5510)
@@ -37,16 +37,16 @@
     private const string ChildParameterName = "Child";
     #region Parameter Properties
-    public ILookupParameter<ItemArray<SymbolicExpressionTree>> ParentsParameter {
-      get { return (ScopeTreeLookupParameter<SymbolicExpressionTree>)Parameters[ParentsParameterName]; }
+    public ILookupParameter<ItemArray<ISymbolicExpressionTree>> ParentsParameter {
+      get { return (ScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[ParentsParameterName]; }
     }
-    public ILookupParameter<SymbolicExpressionTree> ChildParameter {
-      get { return (ILookupParameter<SymbolicExpressionTree>)Parameters[ChildParameterName]; }
+    public ILookupParameter<ISymbolicExpressionTree> ChildParameter {
+      get { return (ILookupParameter<ISymbolicExpressionTree>)Parameters[ChildParameterName]; }
     }
     #endregion
     #region Properties
-    public ItemArray<SymbolicExpressionTree> Parents {
+    public ItemArray<ISymbolicExpressionTree> Parents {
       get { return ParentsParameter.ActualValue; }
     }
-    public SymbolicExpressionTree Child {
+    public ISymbolicExpressionTree Child {
       get { return ChildParameter.ActualValue; }
       set { ChildParameter.ActualValue = value; }
@@ -58,6 +58,6 @@
     protected SymbolicExpressionTreeCrossover()
       : base() {
-      Parameters.Add(new ScopeTreeLookupParameter<SymbolicExpressionTree>(ParentsParameterName, "The parent symbolic expression trees which should be crossed."));
-      Parameters.Add(new LookupParameter<SymbolicExpressionTree>(ChildParameterName, "The child symbolic expression tree resulting from the crossover."));
+      Parameters.Add(new ScopeTreeLookupParameter<ISymbolicExpressionTree>(ParentsParameterName, "The parent symbolic expression trees which should be crossed."));
+      Parameters.Add(new LookupParameter<ISymbolicExpressionTree>(ChildParameterName, "The child symbolic expression tree resulting from the crossover."));
     }
 
@@ -66,5 +66,5 @@
         throw new ArgumentException("Number of parents must be exactly two for symbolic expression tree crossover operators.");
 
-      SymbolicExpressionTree result = Cross(Random, Parents[0], Parents[1]);
+      ISymbolicExpressionTree result = Cross(Random, Parents[0], Parents[1]);
 
       Child = result;
@@ -72,6 +72,6 @@
     }
 
-    protected abstract SymbolicExpressionTree Cross(IRandom random,
-      SymbolicExpressionTree parent0, SymbolicExpressionTree parent1);
+    protected abstract ISymbolicExpressionTree Cross(IRandom random,
+      ISymbolicExpressionTree parent0, ISymbolicExpressionTree parent1);
   }
 }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/DefaultSymbolicExpressionGrammar.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/DefaultSymbolicExpressionGrammar.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/DefaultSymbolicExpressionGrammar.cs	(revision 5510)
@@ -74,5 +74,5 @@
     }
     [Storable]
-    private IEnumerable<KeyValuePair<string, Symbol>> AllSymbols {
+    private IEnumerable<KeyValuePair<string, ISymbol>> AllSymbols {
       get { return allSymbols.AsEnumerable(); }
       set { allSymbols = value.ToDictionary(x => x.Key, x => x.Value); }
@@ -83,7 +83,7 @@
     private Dictionary<string, int> maxSubTreeCount;
     private Dictionary<string, List<List<string>>> allowedChildSymbols;
-    private Dictionary<string, Symbol> allSymbols;
-    [Storable]
-    private Symbol startSymbol;
+    private Dictionary<string, ISymbol> allSymbols;
+    [Storable]
+    private ISymbol startSymbol;
 
     [StorableConstructor]
@@ -103,9 +103,9 @@
       maxSubTreeCount = new Dictionary<string, int>(original.maxSubTreeCount);
 
-      allSymbols = new Dictionary<string, Symbol>();
-      foreach (Symbol symbol in original.allSymbols.Values.Select(s => cloner.Clone(s)))
+      allSymbols = new Dictionary<string, ISymbol>();
+      foreach (ISymbol symbol in original.allSymbols.Values.Select(s => cloner.Clone(s)))
         allSymbols.Add(symbol.Name, symbol);
 
-      startSymbol = cloner.Clone<Symbol>(original.startSymbol);
+      startSymbol = cloner.Clone<ISymbol>(original.startSymbol);
       allowedChildSymbols = new Dictionary<string, List<List<string>>>();
       foreach (var entry in original.allowedChildSymbols) {
@@ -121,5 +121,5 @@
       this.maxSubTreeCount = new Dictionary<string, int>();
       this.allowedChildSymbols = new Dictionary<string, List<List<string>>>();
-      this.allSymbols = new Dictionary<string, Symbol>();
+      this.allSymbols = new Dictionary<string, ISymbol>();
       this.cachedMinExpressionLength = new Dictionary<string, int>();
       this.cachedMaxExpressionLength = new Dictionary<string, int>();
@@ -142,10 +142,10 @@
       this.maxSubTreeCount = new Dictionary<string, int>();
       this.allowedChildSymbols = new Dictionary<string, List<List<string>>>();
-      this.allSymbols = new Dictionary<string, Symbol>();
-
-      this.StartSymbol = (Symbol)cloner.Clone(grammar.StartSymbol);
-
-      foreach (Symbol symbol in grammar.Symbols) {
-        Symbol clonedSymbol = (Symbol)cloner.Clone(symbol);
+      this.allSymbols = new Dictionary<string, ISymbol>();
+
+      this.StartSymbol = (ISymbol)cloner.Clone(grammar.StartSymbol);
+
+      foreach (ISymbol symbol in grammar.Symbols) {
+        ISymbol clonedSymbol = (ISymbol)cloner.Clone(symbol);
         this.AddSymbol(clonedSymbol);
         this.SetMinSubtreeCount(clonedSymbol, grammar.GetMinSubtreeCount(symbol));
@@ -153,9 +153,9 @@
       }
 
-      foreach (Symbol parent in grammar.Symbols) {
+      foreach (ISymbol parent in grammar.Symbols) {
         for (int i = 0; i < grammar.GetMaxSubtreeCount(parent); i++) {
-          foreach (Symbol child in grammar.Symbols) {
+          foreach (ISymbol child in grammar.Symbols) {
             if (grammar.IsAllowedChild(parent, child, i)) {
-              this.SetAllowedChild((Symbol)cloner.Clone(parent), (Symbol)cloner.Clone(child), i);
+              this.SetAllowedChild((ISymbol)cloner.Clone(parent), (ISymbol)cloner.Clone(child), i);
             }
           }
@@ -181,10 +181,10 @@
 
     #region ISymbolicExpressionGrammar Members
-    public Symbol StartSymbol {
+    public ISymbol StartSymbol {
       get { return startSymbol; }
       set { startSymbol = value; }
     }
 
-    public void AddSymbol(Symbol symbol) {
+    public void AddSymbol(ISymbol symbol) {
       if (ContainsSymbol(symbol)) throw new ArgumentException("Symbol " + symbol + " is already defined.");
       allSymbols.Add(symbol.Name, symbol);
@@ -193,5 +193,5 @@
     }
 
-    public void RemoveSymbol(Symbol symbol) {
+    public void RemoveSymbol(ISymbol symbol) {
       foreach (var parent in Symbols) {
         for (int i = 0; i < GetMaxSubtreeCount(parent); i++)
@@ -206,13 +206,13 @@
     }
 
-    public IEnumerable<Symbol> Symbols {
+    public IEnumerable<ISymbol> Symbols {
       get { return allSymbols.Values.AsEnumerable(); }
     }
 
-    public bool ContainsSymbol(Symbol symbol) {
+    public bool ContainsSymbol(ISymbol symbol) {
       return allSymbols.ContainsKey(symbol.Name);
     }
 
-    public void SetAllowedChild(Symbol parent, Symbol child, int argumentIndex) {
+    public void SetAllowedChild(ISymbol parent, ISymbol child, int argumentIndex) {
       if (!ContainsSymbol(parent)) throw new ArgumentException("Unknown symbol: " + parent, "parent");
       if (!ContainsSymbol(child)) throw new ArgumentException("Unknown symbol: " + child, "child");
@@ -222,5 +222,5 @@
     }
 
-    public bool IsAllowedChild(Symbol parent, Symbol child, int argumentIndex) {
+    public bool IsAllowedChild(ISymbol parent, ISymbol child, int argumentIndex) {
       if (!ContainsSymbol(parent)) throw new ArgumentException("Unknown symbol: " + parent, "parent");
       if (!ContainsSymbol(child)) throw new ArgumentException("Unknown symbol: " + child, "child");
@@ -230,5 +230,5 @@
 
     private Dictionary<string, int> cachedMinExpressionLength;
-    public int GetMinExpressionLength(Symbol symbol) {
+    public int GetMinExpressionLength(ISymbol symbol) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       if (!cachedMinExpressionLength.ContainsKey(symbol.Name)) {
@@ -246,5 +246,5 @@
 
     private Dictionary<string, int> cachedMaxExpressionLength;
-    public int GetMaxExpressionLength(Symbol symbol) {
+    public int GetMaxExpressionLength(ISymbol symbol) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       if (!cachedMaxExpressionLength.ContainsKey(symbol.Name)) {
@@ -262,5 +262,5 @@
 
     private Dictionary<string, int> cachedMinExpressionDepth;
-    public int GetMinExpressionDepth(Symbol symbol) {
+    public int GetMinExpressionDepth(ISymbol symbol) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       if (!cachedMinExpressionDepth.ContainsKey(symbol.Name)) {
@@ -275,5 +275,5 @@
     }
 
-    public void SetMaxSubtreeCount(Symbol symbol, int nSubTrees) {
+    public void SetMaxSubtreeCount(ISymbol symbol, int nSubTrees) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       maxSubTreeCount[symbol.Name] = nSubTrees;
@@ -286,5 +286,5 @@
     }
 
-    public void SetMinSubtreeCount(Symbol symbol, int nSubTrees) {
+    public void SetMinSubtreeCount(ISymbol symbol, int nSubTrees) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       minSubTreeCount[symbol.Name] = nSubTrees;
@@ -292,10 +292,10 @@
     }
 
-    public int GetMinSubtreeCount(Symbol symbol) {
+    public int GetMinSubtreeCount(ISymbol symbol) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       return minSubTreeCount[symbol.Name];
     }
 
-    public int GetMaxSubtreeCount(Symbol symbol) {
+    public int GetMaxSubtreeCount(ISymbol symbol) {
       if (!ContainsSymbol(symbol)) throw new ArgumentException("Unknown symbol: " + symbol);
       return maxSubTreeCount[symbol.Name];
@@ -313,5 +313,5 @@
       maxSubTreeCount = new Dictionary<string, int>(original.maxSubTreeCount);
 
-      allSymbols = new Dictionary<string, Symbol>(original.allSymbols);
+      allSymbols = new Dictionary<string, ISymbol>(original.allSymbols);
       startSymbol = original.startSymbol;
       allowedChildSymbols = new Dictionary<string, List<List<string>>>(original.allowedChildSymbols.Count);
@@ -323,5 +323,4 @@
       }
     }
-
   }
 }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeStringFormatter.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeStringFormatter.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeStringFormatter.cs	(revision 5510)
@@ -46,5 +46,5 @@
     }
 
-    public string Format(SymbolicExpressionTree symbolicExpressionTree) {
+    public string Format(ISymbolicExpressionTree symbolicExpressionTree) {
       return FormatRecursively(symbolicExpressionTree.Root, 0);
     }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GlobalSymbolicExpressionGrammar.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GlobalSymbolicExpressionGrammar.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/GlobalSymbolicExpressionGrammar.cs	(revision 5510)
@@ -79,5 +79,5 @@
     }
 
-    public GlobalSymbolicExpressionGrammar(ISymbolicExpressionGrammar mainBranchGrammar)
+    public GlobalSymbolicExpressionGrammar(ISymbolicExpressionTreeGrammar mainBranchGrammar)
       : base(mainBranchGrammar) {
       maxFunctionArguments = 3;
@@ -121,5 +121,5 @@
 
     [Obsolete]
-    private void Initialize(ISymbolicExpressionGrammar mainBranchGrammar) {
+    private void Initialize(ISymbolicExpressionTreeGrammar mainBranchGrammar) {
       base.Clear();
 
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 5510)
@@ -109,7 +109,7 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Analyzers\MinAverageMaxSymbolicExpressionTreeLengthAnalyzer.cs" />
     <Compile Include="Analyzers\SymbolicExpressionSymbolFrequencyAnalyzer.cs" />
-    <Compile Include="Analyzers\MinAverageMaxSymbolicExpressionTreeSizeAnalyzer.cs" />
-    <Compile Include="Analyzers\SymbolicExpressionTreeSizeCalculator.cs" />
+    <Compile Include="Analyzers\SymbolicExpressionTreeLengthCalculator.cs" />
     <Compile Include="ArchitectureManipulators\ArgumentCreater.cs" />
     <Compile Include="ArchitectureManipulators\ArgumentDeleter.cs" />
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbol.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbol.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbol.cs	(revision 5510)
@@ -25,5 +25,5 @@
   public interface ISymbol : INamedItem {
     ISymbolicExpressionTreeNode CreateTreeNode();
-    double InitialFrequency;
+    double InitialFrequency { get; }
   }
 }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTree.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTree.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTree.cs	(revision 5510)
@@ -25,5 +25,5 @@
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
   public interface ISymbolicExpressionTree : IItem {
-    ISymbolicExpressionTreeNode Root { get; }
+    ISymbolicExpressionTreeNode Root { get; set; }
     int Size { get; }
     int Height { get; }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNode.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNode.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/ISymbolicExpressionTreeNode.cs	(revision 5510)
@@ -22,8 +22,9 @@
 using HeuristicLab.Core;
 using System;
+using HeuristicLab.Common;
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
-  public interface ISymbolicExpressionTreeNode : IItem {
+  public interface ISymbolicExpressionTreeNode : IDeepCloneable {
     ISymbolicExpressionTreeGrammar Grammar { get; }
-
+    ISymbolicExpressionTreeNode Parent { get; set; }
     ISymbol Symbol { get; }
     bool HasLocalParameters { get; }
@@ -37,6 +38,6 @@
     IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPostfix();
     IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPrefix();
-    void ForEachNodePostfix(Action<SymbolicExpressionTreeNode> a);
-    void ForEachNodePrefix(Action<SymbolicExpressionTreeNode> a);
+    void ForEachNodePostfix(Action<ISymbolicExpressionTreeNode> a);
+    void ForEachNodePrefix(Action<ISymbolicExpressionTreeNode> a);
 
     IEnumerable<ISymbolicExpressionTreeNode> SubTrees { get; }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/Operators/ISymbolicExpressionTreeManipulator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/Operators/ISymbolicExpressionTreeManipulator.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Interfaces/Operators/ISymbolicExpressionTreeManipulator.cs	(revision 5510)
@@ -28,5 +28,5 @@
   /// </summary>
   public interface ISymbolicExpressionTreeManipulator : ISymbolicExpressionTreeOperator, IManipulator {
-    ILookupParameter<SymbolicExpressionTree> SymbolicExpressionTreeParameter { get; }
+    ILookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter { get; }
   }
 }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/ChangeNodeTypeManipulation.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/ChangeNodeTypeManipulation.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/ChangeNodeTypeManipulation.cs	(revision 5510)
@@ -41,9 +41,9 @@
     }
 
-    protected override void Manipulate(IRandom random, SymbolicExpressionTree symbolicExpressionTree) {
+    protected override void Manipulate(IRandom random, ISymbolicExpressionTree symbolicExpressionTree) {
       ChangeNodeType(random, symbolicExpressionTree);
     }
 
-    public static void ChangeNodeType(IRandom random, SymbolicExpressionTree symbolicExpressionTree) {
+    public static void ChangeNodeType(IRandom random, ISymbolicExpressionTree symbolicExpressionTree) {
 
       // select any node as parent (except the root node)
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/FullTreeShaker.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/FullTreeShaker.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/FullTreeShaker.cs	(revision 5510)
@@ -54,5 +54,5 @@
     }
 
-    protected override void Manipulate(IRandom random, SymbolicExpressionTree tree) {
+    protected override void Manipulate(IRandom random, ISymbolicExpressionTree tree) {
       tree.Root.ForEachNodePostfix(node => {
         if (node.HasLocalParameters) {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/OnePointShaker.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/OnePointShaker.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/OnePointShaker.cs	(revision 5510)
@@ -26,4 +26,5 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Parameters;
+using System.Collections.Generic;
 
 namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
@@ -54,11 +55,11 @@
     }
 
-    protected override void Manipulate(IRandom random, SymbolicExpressionTree tree) {
-      var parametricNodes = from node in tree.IterateNodesPrefix()
-                            where node.HasLocalParameters
-                            select node;
-      if (parametricNodes.Count() > 0) {
+    protected override void Manipulate(IRandom random, ISymbolicExpressionTree tree) {
+      List<ISymbolicExpressionTreeNode> parametricNodes = new List<ISymbolicExpressionTreeNode>();
+      tree.Root.ForEachNodePostfix(n => {
+        if (n.HasLocalParameters) parametricNodes.Add(n);
+      });
+      if (parametricNodes.Count > 0) {
         var selectedPoint = parametricNodes.SelectRandom(random);
-
         selectedPoint.ShakeLocalParameters(random, ShakingFactor.Value);
       }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/SymbolicExpressionTreeManipulator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/SymbolicExpressionTreeManipulator.cs	(revision 5509)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Manipulators/SymbolicExpressionTreeManipulator.cs	(revision 5510)
@@ -36,11 +36,11 @@
 
     #region Parameter Properties
-    public ILookupParameter<SymbolicExpressionTree> SymbolicExpressionTreeParameter {
-      get { return (ILookupParameter<SymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
+    public ILookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
+      get { return (ILookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
     }
     #endregion
 
     #region Properties
-    public SymbolicExpressionTree SymbolicExpressionTree {
+    public ISymbolicExpressionTree SymbolicExpressionTree {
       get { return SymbolicExpressionTreeParameter.ActualValue; }
     }
@@ -52,9 +52,9 @@
     public SymbolicExpressionTreeManipulator()
       : base() {
-      Parameters.Add(new LookupParameter<SymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic expression tree on which the operator should be applied."));
+      Parameters.Add(new LookupParameter<ISymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic expression tree on which the operator should be applied."));
     }
 
     public sealed override IOperation Apply() {
-      SymbolicExpressionTree tree = SymbolicExpressionTreeParameter.ActualValue;
+      ISymbolicExpressionTree tree = SymbolicExpressionTreeParameter.ActualValue;
       Manipulate(RandomParameter.ActualValue, tree);
 
@@ -62,5 +62,5 @@
     }
 
-    protected abstract void Manipulate(IRandom random, SymbolicExpressionTree symbolicExpressionTree);
+    protected abstract void Manipulate(IRandom random, ISymbolicExpressionTree symbolicExpressionTree);
   }
 }
